% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
%
% Boot loader splash code.
%
% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Some global vars.

% Boot loader splash areas to uncover.
%
/bsplash.areas [
  [   0   0  160  44  320 320 ]
  [ 320 200  160 244  320 120 ]
  [ 320   0  160  84  320 200 ]
] def

/uhulinux.areas [
  [  10 320  170 360   48  48 ]
  [  58 320  208 360   48  48 ]
  [ 106 320  246 360   48  48 ]
  [ 154 320  284 360   28  48 ]
  [ 182 320  302 360   40  48 ]
  [ 222 320  332 360   28  48 ]
  [ 250 320  350 360   44  48 ]
  [ 294 320  384 360   44  48 ]
  [ 338 320  418 360   48  48 ]
] def

/madeinhungary.areas [
  [  14 370  174 410   14  14 ]
  [  38 370  198 410   14  14 ]
  [  56 370  216 410   14  14 ]
  [  78 370  238 410   14  14 ]
  [ 110 370  270 410   14  14 ]
  [ 130 370  290 410   14  14 ]
  [ 166 370  326 410   14  14 ]
  [ 188 370  348 410   14  14 ]
  [ 208 370  368 410   14  14 ]
  [ 228 370  388 410   14  14 ]
  [ 250 370  410 410   14  14 ]
  [ 270 370  430 410   14  14 ]
  [ 290 370  450 410   14  14 ]
] def

/szorszalak.areas [
  [ 567 337 ]
  [ 563 351 ]
  [ 566 365 ]
  [ 573 378 ]
  [ 581 329 ]
  [ 578 345 ]
  [ 580 360 ]
  [ 585 372 ]
  [ 587 386 ]
  [ 594 335 ]
  [ 593 349 ]
  [ 596 365 ]
  [ 599 377 ]
  [ 604 388 ]
  [ 608 330 ]
  [ 609 347 ]
  [ 610 360 ]
  [ 611 374 ]
  [ 622 339 ]
  [ 627 352 ]
  [ 627 369 ]
  [ 622 382 ]
] def


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Generate pseudo random number.
% Good enough for boot loader splash screen.
%
% ( ) ==> ( int )
%
/rand {
  rand.seed dup .undef eq exch 0 eq or { /rand.seed time 1 add def } if
  rand.seed dup 6 shr over 30 shr xor 1 and
  exch 1 shl or 0x7fffffff and
  /rand.seed over def
} def


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Show boot loader splash.
%
% ( ) ==> ( )
%
/bsplash.show {
  currentimage

  "splash.pcx" findfile setimage loadpalette
  /max_image_colors max_image_colors image.colors max def

  0 0 moveto currentpoint 1 1 image getpixel setcolor screen.size fillrect

  0 0 moveto getpixel settransparentcolor

  0 1 2 {
    700000 usleep
    bsplash.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
  } for

  300 200 moveto getpixel settransparentcolor

  szorszalak.areas length -1 1 {
    30000 usleep
    rand over mod exch 1 sub
    over szorszalak.areas exch get
    dup 0 get 276 sub over 1 get 152 sub moveto
    dup 0 get exch 1 get 10 10 image
    szorszalak.areas exch get szorszalak.areas 3 1 roll put
  } for
  30000 usleep

  0 0 moveto getpixel settransparentcolor

  uhulinux.areas length -1 1 {
    rand over mod exch 1 sub
    over uhulinux.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
    uhulinux.areas exch get uhulinux.areas 3 1 roll put
    50000 usleep
  } for

  madeinhungary.areas length -1 1 {
    rand over mod exch 1 sub
    over madeinhungary.areas exch get
    dup 2 get over 3 get moveto
    dup 0 get exch dup 1 get exch dup 4 get exch 5 get image
    madeinhungary.areas exch get madeinhungary.areas 3 1 roll put
    50000 usleep
  } for
  50000 usleep

  0 2 20 {
    426 over 64 add moveto
    426 exch 330 add 32 2 image
    30000 usleep
  } for

  -1 settransparentcolor
  setimage
} def


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
% Just wait.
%
% ( ) ==> ( )
%
/bsplash.done {
  1500000 usleep
} def


